//+------------------------------------------------------------------+
//|                                            PivotsForFreebie2.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+


#property copyright "Copyright Eric J Schroeder"
//#property link "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 EMPTY

extern string  StandardOrFib1 = "True will auto switch to Fibs if";
extern string  StandardOrFib2 = "prior day ADR is > avg ADR";
extern bool    AutoSwitchPivots = true;
extern double  PercentADR = 20;
extern string  P1 = "Percent that prior day Range is larger than";
extern string  P2 = "total ADR.  20, 25, 50%, etc.  Whole numbers.";
extern bool    midpivots = true;
extern color   ResColor   = Crimson;
extern color   PivotColor = Wheat;
extern color   SupColor   = LimeGreen;
extern color   MidColor   = Yellow;
extern color   TextColor  = Lavender;
extern int     ShiftLabel = 7;
extern bool    Show.Comment = false;
extern bool    FullScreenLines = true;
extern string  FSL = "If False, lines start at current bar";
extern bool    UseSundayData = true;
extern string  USD1 = "If True, combines Sun w/ Mon";
extern string  USD2 = "False ignores Sunday";
bool DataNormal = true;

color LineColor;
double R=0;
double prior_high=0;
double prior_low=0;
double prior_close=0;
double current_high=0;
double current_low=0;
double P=0;
double R1,R2,R3;
double M0,M1,M2,M3,M4,M5;
double S1,S2,S3;
double H4,H3,L4,L3;
double nP=0;
double nD=0;
double D=0;
double rates_p1[2][6];
double ExtMapBuffer1[];
string Period_Text, LineLabel, PivotLine;
int    LineType;
int    MyPeriod;
int multiplier;
bool   Fib = false;

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;

   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0, ExtMapBuffer1);

   //---- indicators
   R1=0; R2=0; R3=0;
   M0=0; M1=0; M2=0; M3=0; M4=0; M5=0;
   S1=0; S2=0; S3=0;

   //----
   return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete("R3 Label");
   ObjectDelete("R3 Line");
   ObjectDelete("R2 Label");
   ObjectDelete("R2 Line");
   ObjectDelete("R1 Label");
   ObjectDelete("R1 Line");
   ObjectDelete("P Label");
   ObjectDelete("P Line");
   ObjectDelete("S1 Label");
   ObjectDelete("S1 Line");
   ObjectDelete("S2 Label");
   ObjectDelete("S2 Line");
   ObjectDelete("S3 Label");
   ObjectDelete("S3 Line");
   ObjectDelete("M5 Label");
   ObjectDelete("M5 Line");
   ObjectDelete("M4 Label");
   ObjectDelete("M4 Line");
   ObjectDelete("M3 Label");
   ObjectDelete("M3 Line");
   ObjectDelete("M2 Label");
   ObjectDelete("M2 Line");
   ObjectDelete("M1 Label");
   ObjectDelete("M1 Line");
   ObjectDelete("M0 Label");
   ObjectDelete("M0 Line");

   Comment("");
   //----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
   //---- exit if period is greater than hourly charts
   if(Period() > 60)
   {
      Print("Error - Chart period is greater than H1.");
      return(-1); // then exit
   }

   //---- Get new  prices
      MyPeriod = PERIOD_D1;
      Period_Text = "Day";
      if(UseSundayData)
      {
         if(TimeDayOfWeek(iTime(NULL, PERIOD_D1, 1))==0 || TimeDayOfWeek(iTime(NULL, PERIOD_D1, 2))==0)
            DataNormal = false;

         if(TimeDayOfWeek(iTime(NULL, PERIOD_D1, 1))==0)
         {
            current_low  = iLow(NULL, MyPeriod, (iLowest(NULL, MyPeriod, MODE_LOW, 2, 0)));
            current_high = iHigh(NULL, MyPeriod, (iHighest(NULL, MyPeriod, MODE_HIGH, 2, 0)));
            prior_low    = iLow(NULL, MyPeriod, 2);
            prior_high   = iHigh(NULL, MyPeriod, 2);
            prior_close  = iClose(NULL, MyPeriod, 2);
         }
         if(TimeDayOfWeek(iTime(NULL, PERIOD_D1, 2))==0)
         {
            current_low  = iLow(NULL, MyPeriod, 0);
            current_high = iHigh(NULL, MyPeriod, 0);
            prior_low    = iLow(NULL, MyPeriod, (iLowest(NULL, MyPeriod, MODE_LOW, 2, 1)));
            prior_high   = iHigh(NULL, MyPeriod, (iHighest(NULL, MyPeriod, MODE_HIGH, 2, 1)));
            prior_close  = iClose(NULL, MyPeriod, 1);
         }
      }
      else
      {
         if(TimeDayOfWeek(iTime(NULL, PERIOD_D1, 1))==0)
         {
            current_low  = iLow(NULL, MyPeriod, 0);
            current_high = iHigh(NULL, MyPeriod, 0);
            prior_low   = iLow(NULL, MyPeriod, 2);
            prior_high  = iHigh(NULL, MyPeriod, 2);
            prior_close = iClose(NULL, MyPeriod, 2);
         }
      }

   if(DataNormal)
   {
      current_low  = iLow(NULL, MyPeriod, 0);
      current_high = iHigh(NULL, MyPeriod, 0);
      prior_low   = iLow(NULL, MyPeriod, 1);
      prior_high  = iHigh(NULL, MyPeriod, 1);
      prior_close = iClose(NULL, MyPeriod, 1);
   }
   //---- Calculate Pivots

   D = current_high - current_low;
   R = prior_high - prior_low;//range
   P = (prior_high + prior_low + prior_close)/3;// Standard Pivot
   
   Fib = false;
   R3 = (2*P)+(prior_high-(2*prior_low));
   R2 = P+(prior_high - prior_low);
   R1 = (2*P)-prior_low;
   S1 = (2*P)-prior_high;
   S2 = P-(prior_high - prior_low);
   S3 = (2*P)-((2* prior_high)-prior_low);

   if(AutoSwitchPivots)
   {
      int Range2=0,Range3=0,Range4=0,Rg1,Rg2,Rg3,Rg4;
      double Range1=0,RAvg=0,RangePercent;
      int i=0;

      //---- Get new  prices
      MyPeriod = 1440;
      Rg1 = 1;
      Rg2 = 5;
      Rg3 = 10;
      Rg4 = 20;

      Range1 = (iHigh(NULL,MyPeriod,1)-iLow(NULL,MyPeriod,1))/(Point*multiplier);
      for(i=1;i<=Rg2;i++)
         Range2 = Range2+(iHigh(NULL,MyPeriod,i)-iLow(NULL,MyPeriod,i))/(Point*multiplier);
      for(i=1;i<=Rg3;i++)
         Range3 = Range3+(iHigh(NULL,MyPeriod,i)-iLow(NULL,MyPeriod,i))/(Point*multiplier);
      for(i=1;i<=Rg4;i++)
         Range4 = Range4+(iHigh(NULL,MyPeriod,i)-iLow(NULL,MyPeriod,i))/(Point*multiplier);

      Range2 = Range2/Rg2;
      Range3 = Range3/Rg3;
      Range4 = Range4/Rg4;
      RAvg   =(Range1+Range2+Range3+Range4)/4;    

      RangePercent = (Range1 - RAvg) / RAvg;
      if(RangePercent > PercentADR/100)
      {
         Fib = true;
         R3 = P + (R * 1.00);
         R2 = P + (R * 0.618);
         R1 = P + (R * 0.382);
         S1 = P - (R * 0.382);
         S2 = P - (R * 0.618);
         S3 = P - (R * 1.00);
      }
   }
   
   M5 = (R2+R3)/2;
   M4 = (R1+R2)/2;
   M3 = (P+R1)/2;
   M2 = (P+S1)/2;
   M1 = (S1+S2)/2;
   M0 = (S2+S3)/2;

   if (P > 5)
   {
      nP = P;
   }
   else
   {
      nP = P*10000;
   }
//-
   if (D > 5)
   {
      nD = D;
   }
   else
   {
      nD = D*10000;
   }
//-
   if(Show.Comment)
   {
//      Comment("Previous ",Period_Text,"s High= ",prior_high,"   Previous ",Period_Text,"s Range= ",nP,"\nPrevious ",Period_Text,"s Low= ",prior_low,"    Current ",Period_Text,"s Range= ",nD,"\nPrevious ",Period_Text,"s Close= ",prior_close);
      Comment("Range1= ",Range1,"\nRAvg= ",RAvg,"\n(Range1 - RAvg) / RAvg = ",RangePercent ,"\nPercentADR/100= ",PercentADR/100);
      

   P = (prior_high + prior_low + prior_close)/3;// Standard Pivot
   }
   
   if(FullScreenLines)
      LineType = OBJ_HLINE;
   else
      LineType = OBJ_TREND;
      
   //---- Set line labels on chart window

   //---- Pivot Lines//////////////////////////////////////////////////////////////////////

   LineColor = ResColor;
   DrawLine("R3 label", "R3", "R3 line", LineType, LineColor, R3);
   DrawLine("R2 label", "R2", "R2 line", LineType, LineColor, R2);
   DrawLine("R1 label", "R1", "R1 line", LineType, LineColor, R1);
   LineColor = PivotColor;
   if(Fib)
      DrawLine("P label", "Pfib", "P line", LineType, LineColor, P);
   else
      DrawLine("P label", "P", "P line", LineType, LineColor, P);
   LineColor = SupColor;
   DrawLine("S1 label", "S1", "S1 line", LineType, LineColor, S1);
   DrawLine("S2 label", "S2", "S2 line", LineType, LineColor, S2);
   DrawLine("S3 label", "S3", "S3 line", LineType, LineColor, S3);
   LineColor = MidColor;
   DrawLine("M5 label", "M5", "M5 line", LineType, LineColor, M5);
   DrawLine("M4 label", "M4", "M4 line", LineType, LineColor, M4);
   DrawLine("M3 label", "M3", "M3 line", LineType, LineColor, M3);
   DrawLine("M2 label", "M2", "M2 line", LineType, LineColor, M2);
   DrawLine("M1 label", "M1", "M1 line", LineType, LineColor, M1);
   DrawLine("M0 label", "M0", "M0 line", LineType, LineColor, M0);

   DataNormal = true;
   //---- End Of Program
   return(0);
}

//+-------------------------------------------------------------------------------------------+
//| Subroutine to draw pivot lines and labels                                |                                                                                  |
//+-------------------------------------------------------------------------------------------+

void DrawLine(string LineLabel, string LineText, string PivotLine, int LineType, color LineColor, double PriceLine)
   {
      if(ObjectFind(LineLabel) != 0)
      {
         ObjectCreate(LineLabel, OBJ_TEXT, 0, Time[0]+Period()*60*ShiftLabel, PriceLine);
         ObjectSetText(LineLabel, LineText, 8, "Arial", EMPTY);
      }
      else
      {
         ObjectMove(LineLabel, 0, Time[0]+Period()*60*ShiftLabel, PriceLine);
         ObjectSetText(LineLabel, LineText, 8, "Arial", EMPTY);
      }

      if(ObjectFind(PivotLine) != 0)
      {
         ObjectCreate(PivotLine, LineType, 0, Time[1], PriceLine, Time[0], PriceLine);
         ObjectSet(PivotLine, OBJPROP_STYLE, STYLE_DASHDOTDOT);
         ObjectSet(PivotLine, OBJPROP_COLOR, LineColor);
//         ObjectSet(PivotLine, OBJPROP_RAY, true);
      }
      else
      {
         ObjectMove(PivotLine, 0, Time[1], PriceLine);
         ObjectMove(PivotLine, 1, Time[0], PriceLine);
      }
   }
//+------------------------------------------------------------------+

