//+------------------------------------------------------------------+
//|                                      Symphonie_Trendline_nrp.mq4 |
//|                               SuperTrend_nrp adapted by MaryJane |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern int     cciPeriod = 63;
extern int     atrPeriod = 18;


double   Trend[];
double   TrendDoA[];
double   TrendDoB[];
double   Direction[];
int      TimeFrame;

//+------------------------------------------------------------------+
int init()
   {
   IndicatorBuffers(4);
   SetIndexBuffer(0, Trend);
   SetIndexBuffer(1, TrendDoA);
   SetIndexBuffer(2, TrendDoB);
   SetIndexBuffer(3, Direction);
   }

//+------------------------------------------------------------------+
int deinit()
   {
   return(0);
   }

//+------------------------------------------------------------------+
int start()
   {
   int counted_bars = IndicatorCounted();
   int limit, i;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit = MathMax(Bars-counted_bars, Bars-1);

   if (Direction[limit] == -1) CleanPoint(limit, TrendDoA, TrendDoB);

   for(i = limit; i >= 0; i--)
      {
      double cciTrend = iCCI(NULL, 0, cciPeriod, PRICE_TYPICAL, i);
            
      TrendDoA[i] = EMPTY_VALUE;
      TrendDoB[i] = EMPTY_VALUE;
      Trend[i] = Trend[i+1];
      Direction[i] = Direction[i+1];
      if (cciTrend > 0) {Trend[i] = MathMax(Low[i] - iATR(NULL, 0, atrPeriod, i), Trend[i+1]); Direction[i] = 1;}
      if (cciTrend < 0) {Trend[i] = MathMin(High[i] + iATR(NULL, 0, atrPeriod, i), Trend[i+1]); Direction[i] = -1;}
      if (Direction[i] == -1) PlotPoint(i, TrendDoA, TrendDoB, Trend);
      }
      
   return(0);
   }
   
//+------------------------------------------------------------------+
void CleanPoint(int i,double& first[],double& second[])
   {
   if ((second[i] != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE)) 
      second[i+1] = EMPTY_VALUE;
   else if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
      first[i+1] = EMPTY_VALUE;
   }

//+------------------------------------------------------------------+
void PlotPoint(int i,double& first[],double& second[],double& from[])
   {
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {first[i] = from[i]; first[i+1] = from[i+1]; second[i] = EMPTY_VALUE;}
      else {second[i] = from[i]; second[i+1] = from[i+1]; first[i] = EMPTY_VALUE;}
      }
   
   else {first[i] = from[i]; second[i] = EMPTY_VALUE;}
   }


