//+------------------------------------------------------------------+
//|                                Symphonie Trendline MTF Histo.mq4 |
//|                                              adapted by MaryJane |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_width1 4
#property indicator_width2 4
//+------------------------------------------------------------------+
extern string  timeFrame = "Current time frame";
extern int cciPeriod = 63;
//+------------------------------------------------------------------+
double   Up[];
double   Down[];
int      TimeFrame;
string   IndicatorFileName;
//+------------------------------------------------------------------+
int init()
   {
   IndicatorBuffers(2);
   SetIndexBuffer(0, Up);
   SetIndexBuffer(1, Down);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   TimeFrame = stringToTimeFrame(timeFrame);
   IndicatorShortName("TrendLine MTF Histo "+TimeFrameToString(TimeFrame));    
   }
//+------------------------------------------------------------------+
int deinit()
   {
   return(0);
   }
//+------------------------------------------------------------------+
int start()
   {
   int      counted_bars = IndicatorCounted();
   int      limit,i;

   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
      limit = MathMax(Bars-counted_bars,Bars-1);

      if (TimeFrame != Period())
         {
         limit = MathMax(limit,TimeFrame/Period());
         
            for(i=limit; i>=0; i--)
               {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
               double cciTrend = iCCI(NULL, TimeFrame, cciPeriod, PRICE_TYPICAL, y);
                  
               Up[i]  = 0;
               Down[i]  = 0;
               if (cciTrend>0) Up[i] =  1;
               if (cciTrend<0) Down[i] = 1;
               }
         
         return(0);         
         }
      
   for(i = limit; i >= 0; i--)
      {
         cciTrend = iCCI(NULL, 0, cciPeriod, PRICE_TYPICAL, i);
                     
         Up[i]  = 0;
         Down[i]  = 0;
         if (cciTrend>0) Up[i] =  1;
         if (cciTrend<0) Down[i] = 1;
       }
   
   return(0);
   }
//+------------------------------------------------------------------+
int stringToTimeFrame(string tfs)
   {
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
   }
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
   {
   string tfs="";
   if (Period()!=tf)
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
      }
   return(tfs);
   }
//+------------------------------------------------------------------+
string StringUpperCase(string str)
   {
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
         else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
      }
   return(s);
   }